<template>
  <div class="ob-spot__status">
    <div class="status" :class="attentionClass">
      {{ status }}
    </div>
    <div class="toolbar">
      <i
          v-if="!isEnded"
          class="icon close"
          @click="$emit('remove', item)"
      />
      <i class="icon copy" @click="$emit('copy')"/>
      <i
          v-if="isSpotList && isAuctionEnded && hasCarrierTitle"
          class="icon handshake"
          @click="$emit('assignTo')"
      />
    </div>
  </div>
</template>

<script>
  import { ORDER_STATUS } from '@/resources/enum';

  export default {
    name: 'status',
    components: {},
    props: {
      typeAuction: {
        type: String,
        default: ''
      },
      item: {
        type: Object,
        default: () => {
        }
      }
    },
    computed: {
      status() {
        return this.item.orderStatus ? ORDER_STATUS[this.item.orderStatus] : '–'
      },
      attentionClass() {
        return {
          '-light-raspberry-red': ORDER_STATUS[this.item.orderStatus] === ORDER_STATUS.CANCELLED && this.typeAuction === 'list'
            || ORDER_STATUS[this.item.orderStatus] === ORDER_STATUS.AUCTION_ENDED && this.typeAuction === 'spot-list'
        }
      },
      isSpotList() {
        return this.typeAuction === 'spot-list'
      },
      isEnded() {
        return this.typeAuction === 'ended'
      },
      isAuctionEnded() {
        return this.item.orderStatus === 'AUCTION_ENDED'
      },
      hasCarrierTitle() {
        return this.item.carrier.title !== null
      },
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/variables";

  .ob-spot__status {
    position: relative;
    z-index: 1;
    min-height: 20px;

    .toolbar {
      display: none;
      position: absolute;
      top: 0;
      bottom: 0;
      right: 0;
      width: 100%;
      background-color: $light-lavender;

      .icon {
        color: $color-blue-navy-blue;
        font-size: 22px;
        position: absolute;
        top: 50%;
        margin-top: -11px;

        &:nth-of-type(3) {
          right: 82px;
        }

        &:nth-of-type(2) {
          right: 42px;
        }

        &:nth-of-type(1) {
          right: 0;
        }

        &:hover {
          cursor: pointer;
        }
      }
    }
  }

  .table-data tr:hover {
    .toolbar {
      display: block;
    }
  }

</style>
